/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// AccountsObj struct for AccountsObj
type AccountsObj struct {
	// A list of addresses.
	Addresses *[]string `json:"addresses,omitempty"`
}

// NewAccountsObj instantiates a new AccountsObj object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccountsObj() *AccountsObj {
	this := AccountsObj{}
	return &this
}

// NewAccountsObjWithDefaults instantiates a new AccountsObj object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountsObjWithDefaults() *AccountsObj {
	this := AccountsObj{}
	return &this
}

// GetAddresses returns the Addresses field value if set, zero value otherwise.
func (o *AccountsObj) GetAddresses() []string {
	if o == nil || o.Addresses == nil {
		var ret []string
		return ret
	}
	return *o.Addresses
}

// GetAddressesOk returns a tuple with the Addresses field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountsObj) GetAddressesOk() (*[]string, bool) {
	if o == nil || o.Addresses == nil {
		return nil, false
	}
	return o.Addresses, true
}

// HasAddresses returns a boolean if a field has been set.
func (o *AccountsObj) HasAddresses() bool {
	if o != nil && o.Addresses != nil {
		return true
	}

	return false
}

// SetAddresses gets a reference to the given []string and assigns it to the Addresses field.
func (o *AccountsObj) SetAddresses(v []string) {
	o.Addresses = &v
}

func (o AccountsObj) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Addresses != nil {
		toSerialize["addresses"] = o.Addresses
	}
	return json.Marshal(toSerialize)
}

type NullableAccountsObj struct {
	value *AccountsObj
	isSet bool
}

func (v NullableAccountsObj) Get() *AccountsObj {
	return v.value
}

func (v *NullableAccountsObj) Set(val *AccountsObj) {
	v.value = val
	v.isSet = true
}

func (v NullableAccountsObj) IsSet() bool {
	return v.isSet
}

func (v *NullableAccountsObj) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccountsObj(val *AccountsObj) *NullableAccountsObj {
	return &NullableAccountsObj{value: val, isSet: true}
}

func (v NullableAccountsObj) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccountsObj) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
